unit unMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    btnStop: TButton;
    btnReset: TButton;
    imgF: TImage;
    imgB: TImage;
    labHops: TLabel;
    timMover: TTimer;
    procedure btnResetClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure timMoverTimer(Sender: TObject);
  private

  public

  end;

var
  frmMain: TfrmMain;

implementation

{$R *.lfm}

{ TfrmMain }

Var hops :integer;

procedure TfrmMain.btnStopClick(Sender: TObject);
begin
  //toggle timer state
  //also change the caption of the button

  if (timMover.enabled)
    then begin
            //timer is ticking, so stop it
            timMover.enabled := false;
            btnStop.caption := 'start'
         end
    else begin
           //otherwise it is not on, start it
           timMover.enabled := true;
           btnStop.caption := 'stop'
         end;




end;

procedure TfrmMain.btnResetClick(Sender: TObject);
begin
  imgB.top := random(clientheight-imgB.height);
  imgB.left := random(clientwidth-imgB.width);
  imgF.top := random(clientheight-imgB.height);
  imgB.left := random(clientwidth-imgB.width);
  hops := 0;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  //initialise stuff here
  randomize;  //seeds the random number generator

  hops := 1

end;

procedure TfrmMain.timMoverTimer(Sender: TObject);
var x1,x2,y1,y2 : integer;
    d : real;


begin
  //move the bee
  {imgB.top := random(clientheight-imgB.height);
  imgB.left := random(clientwidth-imgB.width); }
  imgB.top := imgB.top + random(21)-10;
  imgB.left := imgB.left + random(21)-10;
  //
  //work out distance
  //bee centre
  x1 := imgB.left + imgB.width div 2;
  y1 := imgB.top + imgB.height div 2;
  //flower centre
  x2 := imgF.left + imgF.width div 2;
  y2 := imgF.top + imgF.height div 2;
  //work out the distance
  d := sqrt(sqr(x2-x1)+sqr(y2-y1));

  //ask if it has hit the flower yet
  if d < 50
 { if ((imgB.left >= imgF.left) and
      (imgB.top >= imgF.top) and
      ((imgF.top+imgF.height)>=(imgB.top+imgB.height)) and
      ((imgF.left+imgF.width)>=(imgB.left+imgB.width)))}
    then begin
            //bee found food - yay!
            timMover.enabled := false
         end;

  //update hop counter
  //hops := hops + 1
  inc(hops);
  labHops.caption := inttostr(hops)

  //is bee deaded? Energy budget
  if (hops > 1500)
    then begin
            timMover.enabled := false;
            labHops.caption := 'RIP you stupid Bee'
         end;

end;



end.


{to do list
 - reset button (etc)

}
